



-- LSW Blizzard Interface

-- also works with doublewide tradeskills and tradeskillHD and should work with any other mod that keeps the normal name pattern for tradeskill buttons -- that is: TradeSkillSkillXXX


do
	local buttonNamePattern = "TradeSkillSkill(%d+)"
	local buttonTextNamePattern = "TradeSkillSkill%d"

	local skillWidth
	local oldShowWindow

	local skillWidthNarrow = 205
	local skillWidthWide = 225

	local numSkillButtons = 1



	local function GetSkillListWidth()
		return skillWidth
	end

	function LSW:GetAllButtons()
		local result = {}
		local numTradeSkills = GetNumTradeSkills();
		local skillOffset = FauxScrollFrame_GetOffset(TradeSkillListScrollFrame);

		for i=1, TRADE_SKILLS_DISPLAYED, 1 do
			local skillIndex = i + skillOffset;
			local skillName, skillType, numAvailable, isExpanded = GetTradeSkillInfo(skillIndex);
			local skillButton = getglobal("TradeSkillSkill"..i);
			if ( skillIndex <= numTradeSkills ) then	
				result[#result + 1] = skillButton
			end
		end

		return result
	end

	local function UpdateWindow()
		local buttons = LSW.GetAllButtons()

		for i=1, #buttons, 1 do
			local button = buttons[i] 
            
            if button then
				local skillName, skillType, itemLink, recipeLink, itemID  = LSW:GetTradeSkillData(i)
				LSW:FilterButtonText(button, itemID)
            end
		end
	end




	local function ShowWindow()
		LSW:CreateTimer("updateData", 0.1, LSW.UpdateData)
		skillWidth = skillWidthWide
		UpdateWindow()
	end




	local function Init()
		TradeSkillTypeColor["optimal"]	= { r = 1.00, g = 0.50, b = 0.25,	font = LSWFontNormalLeftOrange }
		TradeSkillTypeColor["medium"]	= { r = 1.00, g = 1.00, b = 0.00,	font = LSWFontNormalLeftYellow }
		TradeSkillTypeColor["easy"]		= { r = 0.25, g = 0.75, b = 0.25,	font = LSWFontNormalLeftLightGreen }
		TradeSkillTypeColor["trivial"]	= { r = 0.50, g = 0.50, b = 0.50,	font = LSWFontNormalLeftGrey }
		TradeSkillTypeColor["header"]	= { r = 1.00, g = 0.82, b = 0,		font = GameFontNormalSmallLeft }

        hooksecurefunc(TradeSkillFrame, "Show", ShowWindow)
		hooksecurefunc("TradeSkillFrame_Update", function()
			UpdateWindow()
            if RefreshAllDynamicButtons then
                RefreshAllDynamicButtons()
            end
        end)

		skillWidth = skillWidthNarrow

		LSW.RefreshWindow = UpdateWindow

		LSW.GetSkillListWidth = GetSkillListWidth

		LSW.parentFrame = TradeSkillFrame

		LSW.buttonNamePattern = buttonNamePattern
		LSW.buttonTextNamePattern = buttonTextNamePattern
	end


-- only use the standard ui if no other supported ui is present
	local function Test(index)
		local test = true
		frameSupportList = LSW:GetFrameSupportList()

		for i=1,#frameSupportList do
			if i ~= index then
				if frameSupportList[i].Test(i) then
					test = false
				end
			end
		end

		return test
	end


	LSW:RegisterFrameSupport("BlizzardUI", Test, Init)
end




